' Demo fr das EA KIT128-V24 und EA 9719-V24
' Darstellung von 8 Bargraphs auf dem Display als Sinuswelle

DECLARE SUB clrlcd ()
DECLARE SUB cursor (status!)
DECLARE SUB rahmen (x1!, y1!, x2!, y2!)
DECLARE SUB font (fontnr!)
DECLARE SUB stringout (x!, y!, text$)
DECLARE SUB defbar (barnr!, x1!, y1!, x2!, y2!, aw!, ew!)
DECLARE SUB bar (barnr!, barwert!)
DECLARE SUB warte (zehntelsek!)

PRINT "****************************************************************"
PRINT "*  Darstellung von 8 Bargraphs auf dem Display als Sinuswelle  *"
PRINT "****************************************************************"

' Zuerst einmal COM1 initialisieren und Ausgabekanal #1 zuweisen
OPEN "COM1:1200,N,8,1,BIN" FOR OUTPUT AS #1

CALL clrlcd                                   ' Display lschen
CALL cursor(0)                                ' Cursor unsichtbar
CALL rahmen(0, 0, 127, 63)                    ' Rechteck zeichnen
CALL font(3)                                  ' Zeichensatz 8x16
CALL stringout(8, 1, "EA KIT128 Demo")        ' berschrift ausgeben

FOR barnr = 1 TO 8                            ' die 8 Bar's definieren
   x = (barnr - 1) * 14 + 9
   CALL defbar(barnr, x, 20, x + 12, 61, 0, 100)
NEXT

PRINT "Abbruch durch Tastendruck"

winkel = 0                                ' 8 Bars als Sinuswelle darstellen
WHILE (INKEY$ = "")
   FOR barnr = 1 TO 8
      barwert = 50 * (SIN((winkel + barnr * 30) * 3.14 / 180) + 1)
      CALL bar(barnr, barwert)
   NEXT
   winkel = winkel + 30
   IF (winkel >= 360) THEN
      winkel = 0
   END IF
   CALL warte(1)                               ' 1/10s warten
WEND

CLOSE #1

END

SUB bar (barnr, barwert)
    PRINT #1, CHR$(27); "-"; CHR$(barnr); CHR$(barwert)
END SUB

SUB clrlcd
    PRINT #1, CHR$(12)
END SUB

SUB cursor (status)
    PRINT #1, CHR$(27); "C"; CHR$(status)
END SUB

SUB defbar (barnr, x1, y1, x2, y2, aw, ew)
    PRINT #1, CHR$(27); "-"; "O"; CHR$(barnr); CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2); CHR$(aw); CHR$(ew)
END SUB

SUB font (fontnr)
    PRINT #1, CHR$(27); "F"; CHR$(fontnr)
END SUB

SUB rahmen (x1, y1, x2, y2)
    PRINT #1, CHR$(27); "R"; CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2)
END SUB

SUB stringout (x, y, text$)
    PRINT #1, CHR$(27); "Z"; CHR$(x); CHR$(y); text$; CHR$(0)
END SUB

SUB warte (zehntelsek)
    PRINT #1, CHR$(27); "!"; CHR$(zehntelsek)
END SUB

